/**************************************************************************//**
 * @file     system_iMX7D_M4.h
 * @brief    CMSIS Device System Header File for
 *           iMX7D_M4 Device
 * @version  V1.00
 * @date     05. February 2016
 ******************************************************************************/
/* Copyright (c) 2016 ARM LIMITED

   All rights reserved.
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
   - Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
   - Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
   - Neither the name of ARM nor the names of its contributors may be used
     to endorse or promote products derived from this software without
     specific prior written permission.
   *
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL COPYRIGHT HOLDERS AND CONTRIBUTORS BE
   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGE.
   ---------------------------------------------------------------------------*/

#ifndef SYSTEM_iMX6SX_M4_H_
#define SYSTEM_iMX6SX_M4_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>


#ifndef DISABLE_WDOG
  #define DISABLE_WDOG                 1
#endif

#ifdef CLOCK_SETUP
  #if   (CLOCK_SETUP == 0)
    #define DEFAULT_SYSTEM_CLOCK         10000000u
  #elif (CLOCK_SETUP == 1)
    #define DEFAULT_SYSTEM_CLOCK         10000000u
  #elif (CLOCK_SETUP == 2)
    #define DEFAULT_SYSTEM_CLOCK         10000000u
  #elif (CLOCK_SETUP == 3)
    #define DEFAULT_SYSTEM_CLOCK         10000000u
  #elif (CLOCK_SETUP == 4)
    #define DEFAULT_SYSTEM_CLOCK         10000000u
  #elif (CLOCK_SETUP == 5)
    #define DEFAULT_SYSTEM_CLOCK         10000000u
  #endif
#else
    #define DEFAULT_SYSTEM_CLOCK         10000000u
#endif

/**
  \brief  System clock frequency (core clock).
    The system clock frequency supplied to the SysTick timer and the 
    processor core clock.
 */
extern uint32_t SystemCoreClock;

/**
  \brief  Setup the microcontroller system.

    Initialize the System and update the SystemCoreClock variable.
 */
void SystemInit (void);

/**
  \brief  Update SystemCoreClock variable.

    Updates the SystemCoreClock with current core Clock
    retrieved from cpu registers.
 */
void SystemCoreClockUpdate (void);

#ifdef __cplusplus
}
#endif

#endif  /* #ifndef SYSTEM_iMX6SX_M4_H_ */
