/* -----------------------------------------------------------------------------
 * Copyright (c) 2016 ARM Ltd.
 *
 * This software is provided 'as-is', without any express or implied warranty.
 * In no event will the authors be held liable for any damages arising from
 * the use of this software. Permission is granted to anyone to use this
 * software for any purpose, including commercial applications, and to alter
 * it and redistribute it freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software in
 *    a product, an acknowledgment in the product documentation would be
 *    appreciated but is not required.
 *
 * 2. Altered source versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.
 *
 * 3. This notice may not be removed or altered from any source distribution.
 *
 *
 * $Date:        22. July 2016
 * $Revision:    V1.00
 *
 * Project:      IO Retargeting to USART for iMX7D SABRE Board
 * -------------------------------------------------------------------------- */

#include "retarget_io_user.h"
#include "iMX7D_M4.h"
#include "board.h"

#if defined (__CC_ARM)
  #pragma import __use_no_semihosting
#elif defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
  __ASM(".global __use_no_semihosting");	
#else
  #error Not supported compiler type
#endif

void InitRetargetIOUSART(void) {
  dbg_uart_init();
}

int stdin_getchar (void) {
	uint32_t urxd = 0;
	while (((urxd = UART2->URXD) & (1<<15)) == 0); // CHARRDY?
	return (uint8_t)(urxd & 0xFF);
}

static __inline int writechar(int ch) {
	while (UART2->UTS & (1<<4));  // Wait for TX FIFO not full
	UART2->UTXD = (uint8_t)(ch & 0xFF);
	return (0);
}

int stdout_putchar (int ch) {
	return writechar(ch);
}

int stderr_putchar (int ch) {
	return writechar(ch);
}

void ttywrch (int ch) {
	writechar(ch);
}

void _sys_exit(int return_code)
{
    while(1);
}

char *_sys_command_string(char *cmd, int len) {
	return (0);
}
